import numpy as np
import matplotlib.pyplot as plt 
import sounddevice as sd
from scipy.signal import butter, filtfilt

array_data = np.load("data.npy")
array_data = array_data.flatten()

#print(array_data)
sample_rate = 19600
t = np.arange(len(array_data))/sample_rate
#t = np.linspace(0,1,len(array_data))
#print(len(array_data))

# sd.play(array_data,19600) # 听起来有点像电话铃声
# sd.wait()

# 设计带通滤波器
def butter_bandpass(lowcut, highcut, fs, order=4):
    nyquist = 0.5 * fs
    low = lowcut / nyquist
    high = highcut / nyquist
    b, a = butter(order, [low, high], btype='band')
    return b, a

def butter_bandpass_filter(data, lowcut, highcut, fs, order=4):
    b, a = butter_bandpass(lowcut, highcut, fs, order=order)
    y = filtfilt(b, a, data)
    return y

def fourier_singal(signal):
    # 执行傅立叶变换
    fourier_transform = np.fft.fft(signal)
    frequencies = np.fft.fftfreq(len(signal))

    # 计算单边频谱
    half = len(frequencies) // 2
    frequencies = frequencies[:half]
    fourier_transform = fourier_transform[:half]

    # 将频谱移到中心
    fourier_transform = np.fft.fftshift(fourier_transform)
    frequencies = np.fft.fftshift(frequencies)
    return frequencies, fourier_transform

# 定义带通滤波器的频率范围
lowcut = 80
highcut = 500

freq, fourier_transform = fourier_singal(array_data)

# 应用带通滤波器
filtered_signal = butter_bandpass_filter(array_data, lowcut, highcut, sample_rate)
#freq_f, fourier_transform_f = fourier_singal(filtered_signal)

s_high = array_data - filtered_signal

#freq_h, fourier_transform_h = fourier_singal(s_high)

lowcut1 = 500
highcut1 = 1000

s1 = butter_bandpass_filter(array_data,lowcut1,highcut1,sample_rate)
freq_h, fourier_transform_h = fourier_singal(s1)


# s1[s1>0.5] -= 0.5
# s1[s1<-0.5] += 0.5
# s1[(-0.5 <= s1) & (s1 <= 0.5)] = 0

np.savetxt('signal.csv',s1,delimiter=',')

plt.figure()

plt.subplot(1,2,1)
plt.plot(freq,np.abs(fourier_transform))

plt.subplot(1,2,2)
plt.plot(freq_h,np.abs(fourier_transform_h))
plt.grid()

plt.figure()
plt.plot(t,s1)
plt.grid()

plt.figure()
plt.subplot(2,1,1)
plt.plot(t,array_data)

plt.subplot(2,1,2)
plt.plot(freq,np.abs(fourier_transform))
# 从图中观察应该周期是0.02s 

# plt.subplot(2,2,3)
# plt.plot(t,filtered_signal)

# plt.subplot(2,2,4)
# plt.plot(freq_f,np.abs(fourier_transform_f))

plt.grid()
plt.show()